
setClass("fromSNPper", representation(toolInfo="matrix"), "VIRTUAL")

setClass("SNPperMeta", representation(
  popDetails="data.frame", geneDetails="data.frame", 
  submitters="ANY"), contains=c("matrix", "fromSNPper"))

setGeneric("popDetails", function(object)standardGeneric("popDetails"))
setMethod("popDetails", "SNPperMeta", function(object)
 object@popDetails)
setGeneric("geneDetails", function(object)standardGeneric("geneDetails"))
setMethod("geneDetails", "SNPperMeta", function(object)
 object@geneDetails)
setGeneric("submitters", function(object)standardGeneric("submitters"))
setMethod("submitters", "SNPperMeta", function(object)
 object@submitters)
setGeneric("toolInfo", function(object)standardGeneric("toolInfo"))
setMethod("toolInfo", "fromSNPper", function(object)
 object@toolInfo)

setMethod("show", "SNPperMeta", function(object) {
 cat("SNPper SNP metadata:\n")
 print(object@.Data)
 cat("There are details on", nrow(popDetails(object)), "populations\n")
 cat("and", nrow(geneDetails(object)), "connections to gene features\n")
 cat("SNPper info:\n")
 print(toolInfo(object))
})

#-------------

setClass("SNPperGeneMeta", representation(allGeneMeta="data.frame"),
  contains="fromSNPper")
setGeneric("allGeneMeta", function(x) standardGeneric("allGeneMeta"))
setMethod("allGeneMeta", "SNPperGeneMeta", function(x) x@allGeneMeta)
setMethod("show", "SNPperGeneMeta", function(object) {
 cat("SNPper Gene metadata:\n")
 cat("There are ", nrow(allGeneMeta(object)), "entries.\n")
 cat("Basic information:\n")
 print(allGeneMeta(object)[1,])
 cat("SNPper info:\n")
 print(toolInfo(object))
})
