\name{SNPperMeta-class}

\docType{class}
\alias{SNPperMeta-class}
\alias{SNPperGeneMeta-class}
\alias{fromSNPper-class}
\alias{doSnpinfo}
\alias{doGeneinfo}
\alias{allGeneMeta}
\alias{geneDetails}
\alias{popDetails}
\alias{submitters}
\alias{toolInfo}
\alias{geneDetails,SNPperMeta-method}
\alias{popDetails,SNPperMeta-method}
\alias{submitters,SNPperMeta-method}
\alias{show,SNPperMeta-method}
\alias{show,SNPperGeneMeta-method}
\alias{toolInfo,fromSNPper-method}
\alias{allGeneMeta,SNPperGeneMeta-method}

\title{Class "SNPperMeta" representing data on SNPs curated at snpper.chip.org }
\description{	 gives immediate access to location and allele, methods
extract material
on allele frequencies in different populations, and relationships to
particular mRNAs/genes.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SNPperMeta", ...)}.
The extend matrix (so that colnames are propagated).
}
\section{Slots}{
	 \describe{
    \item{\code{.Data}:}{Object of class \code{"matrix"} see example }
    \item{\code{popDetails}:}{Object of class \code{"data.frame"} 
information on populations that have been genotyped for reference }
    \item{\code{geneDetails}:}{Object of class \code{"data.frame"} information
on mRNAs (typically) near the SNP; putative SNP roles (in Promoter,
3' UTR, or Exon) are often denoted} 
    \item{\code{submitters}:}{Object of class \code{"ANY"} unprocessed
XML on submitter identity. }
  }
}
\section{Extends}{
Class \code{"matrix"}, from data part.
Class \code{"structure"}, by class \code{"matrix"}.
Class \code{"array"}, by class \code{"matrix"}.
Class \code{"vector"}, by class "matrix", with explicit coerce.
Class \code{"vector"}, by class "matrix", with explicit coerce.
}
\section{Methods}{
popDetails, geneDetails, submitters functions are available.
}
\references{ \url{snpper.chip.org} }
\author{ VJ Carey <stvjc@channing.harvard.edu> }
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\link{CLASSNAME-class}} for links to other classes
%}
\examples{
if (interactive()) {
lkc = SNPinfo("6060535")
lkc
popDetails(lkc)
geneDetails(lkc)
lkg = geneInfo("CPNE1")
lkg
dim(allGeneMeta(lkg))
 }
}
\keyword{classes}
